%%% File    : user_default.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created : 11 Nov 2004 by  <svg@surnet.ru>

%%
%% $Id$
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(user_default).

-compile(export_all).

-include_lib("kernel/include/file.hrl").

ok(T) when tuple(T), size(T) >= 2, element(1, T) == ok -> element(2, T);
ok(E) -> erlang:fault({not_ok, E}).

ok2(T) when tuple(T), size(T) >= 3, element(1, T) == ok -> element(3, T);
ok2(E) -> erlang:fault({not_ok, E}).

ok3(T) when tuple(T), size(T) >= 4, element(1, T) == ok -> element(4, T);
ok3(E) -> erlang:fault({not_ok, E}).

mm() ->
  modified_modules().

modified_modules() ->
  [M || {M, _} <-  code:all_loaded(), module_modified(M) == true].

module_modified(Module) ->
  case code:is_loaded(Module) of
    {file, preloaded} ->
      false;
    {file, Path} ->
      CompileOpts = proplists:get_value(compile, Module:module_info()),
      CompileTime = proplists:get_value(time, CompileOpts),
      Src = proplists:get_value(source, CompileOpts),
      module_modified(Path, CompileTime, Src);
    _ ->
      false
  end.

module_modified(Path, PrevCompileTime, PrevSrc) ->
  case find_module_file(Path) of
    false ->
      false;
    ModPath ->
      {ok, {_, [{_, CB}]}} = beam_lib:chunks(ModPath, ["CInf"]),
      CompileOpts =  binary_to_term(CB),
      CompileTime = proplists:get_value(time, CompileOpts),
      Src = proplists:get_value(source, CompileOpts),
      not ((CompileTime == PrevCompileTime) and (Src == PrevSrc))
  end.

find_module_file(Path) ->
  case file:read_file_info(Path) of
    {ok, _} ->
      Path;
    _ ->
      %% may be the path was changed?
      case code:where_is_file(filename:basename(Path)) of
	non_existing ->
	  false;
	NewPath ->
	  NewPath
      end
  end.
