%%%-------------------------------------------------------------------
%%% File    : agent_context.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%%
%%% Created : 10 May 2004 by  <svg@surnet.ru>
%%%-------------------------------------------------------------------
%%
%% $Id$
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(lgi.agent_context).

-export([new/0, set/2, set/3, get/2, delete/2, to_list/1]).

-import(gb_trees).
-import(lists).

new() ->
  gb_trees:empty().

set(KVs, CS) when is_list(KVs) ->
  lists:foldl(fun ({K, V}, C) -> set(K, V, C) end, CS, KVs).

set(K, V, CS) ->
  gb_trees:enter(K, V, CS).

get(K, CS) ->
  case gb_trees:lookup(K, CS) of
    {value, V} ->
      V;
    none ->
      undefined
  end.

delete(K, CS) ->
  gb_trees:delete_any(K, CS).

to_list(CS) ->
 gb_trees:to_list(CS).
 
