%%%-------------------------------------------------------------------
%%% File    : ets_dict.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%%
%%% Created : 10 Sep 2003 by  <svg@surnet.ru>
%%%-------------------------------------------------------------------
%%
%% $Id: ets_dict.erl,v 1.1 2003/10/27 16:58:24 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(phrase.ets_dict).

-behaviour(phrase).

-export([start_link/3]).
-export([lookup_phrase/2, write_phrase/4, clear_dict/1, terminate/1, init/1]).

-import(phrase).
-import(ets).

-record(phrase, {key, phrase, param_names=[]}).
-define(phrase(K, P, PNs), #phrase{key=K, phrase=P, param_names=PNs}).

start_link(Name, TableName, Opts) ->
  phrase:start_link(Name, ?MODULE, TableName, Opts).

init(TableName) ->
  {ok, ets:new(TableName, [set, {keypos, 2}])}.

lookup_phrase(Key, T) ->
  case ets:lookup(T, Key) of
    [?phrase(_, P, PNs)] ->
      {ok, P, PNs, T};
    [] ->
      {undefined, T}
  end.

write_phrase(Key, Phrase, ParamNames, T) ->
  ets:insert(T, ?phrase(Key, Phrase, ParamNames)),
  {ok, T}.

clear_dict(T) ->
  ets:delete_all_objects(T),
  {ok, T}.

terminate(_) ->
  ok.
