%%%-------------------------------------------------------------------
%%% File    : property_supervisor.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%%
%%% Created :  3 Jun 2004 by  <svg@surnet.ru>
%%%-------------------------------------------------------------------
%%
%% $Id$
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(property_supervisor).

-behaviour(supervisor).


%% External exports
-export([start_link/4, stop/1]).

%% Internal exports
-export([init/1]).

-import(wslib.props).

%% External functions

%% Args = [{file_format, clike},
%%         {parse_env, []},
%%         {appsup_spec, {{one_for_one, 0, 300}, []}
%%        ]
start_link(ConfigRef, HlrMod, HlrArg, Args) ->
  supervisor:start_link(?MODULE, {config, ConfigRef, HlrMod, HlrArg, Args}).

stop(ConfigRef) ->
  property_server:stop(ConfigRef).

%% Server functions
init({config, ConfigRef, HlrMod, HlrArg, Args}) ->
  AppSupSpec = props:gv(appsup_spec, Args, {{one_for_one, 0, 300}, []}),
  AppSupId = property_appsup,
  AppSup = {AppSupId,
	    {supervisor, start_link, [?MODULE, {appsup, AppSupSpec}]},
	    permanent, infinity, supervisor, [supervisor]
	   },
  ConfigArgs = [ConfigRef,
		property_supervisor_handler,
		{self(), AppSupId, HlrMod, HlrArg},
		props:delete(appsup_spec, Args)
	       ],
  Config = {property_server,
	    {property_server, start_link, ConfigArgs},
	    permanent, 5000, worker, [property_server]
	   },
  process_flag(trap_exit, true),
  {ok,{{rest_for_one, 0, 300}, [Config, AppSup]}};
init({appsup, Spec}) ->
  process_flag(trap_exit, true),
  {ok, Spec}.

%% Internal functions

