-record(msg_arg, {name, value, mandatory,
		  type % argument type (text, integer, ...)
		 }).

-record(service_attr, {default_attr=deny, args=[]}).

-record(a3_attr_key, {id, name}).

-record(a3_global, {name, value}).

-record(a3_user,   {id, type=user}). %type = user | group | enable
-record(a3_attr,   {id=#a3_attr_key{id=#a3_user{}}, value}).

-record(a3_nas,   {ip, info}).

-record(a3_nas_attr,   {id=#a3_attr_key{}, value}).

-record(a3_passwd_key, {userid=#a3_user{}, type=global}).
-record(a3_passwd,  {id=#a3_passwd_key{},
                     crypt=des,
                     value="*"
                    }).

-record(a3_service_key, {id=#a3_user{}, type, name}).
-record(a3_service, {id=#a3_service_key{}, protocol=nil, attrs=undefined}).


%%**
%% .** #acctask_id{}
%%
%%  Tacacs account task id
%%
%% .src
-record(acctask_id, {host, %AS host IP
                     id    %AS task Id
                    }).
%% ./
%%
%% .= DESCRIPTION
%%
%% Id is equal to task_id argument of Tacacs accounting packet.
%% This pair unique identifies  AS session.
%%
%%*



%%**
%% .** #acctask{}
%%
%%  AS session tracking info.
%%
%% .src

-record(acctask, {task_id=#acctask_id{}, %Session identity
                  userid=#userid{},      %Userid from tacacs packet
                  completed=false,       %Has been stop packet received
                  start_attrs=[],        %Start attributes [#msg_arg]
                  stop_attrs=[]          %Stop attributes [#msg_arg]
                 }).
%% ./
%%
%% .= DESCRIPTION
%%
%% Ordinarily session completeness is identified by session start and
%% session stop packages so we need to keep this info during the session
%%
%%*
