ESRC += $(wildcard tacacs/src/*.erl) $(wildcard tacacs/src/aaa/*.erl)
EPACKAGES += tacacs/src/aaa
EAPP_SRC += tacacs/src/tacacs.app.src

TACACSRC = tacacs/bin/tacacsrc.sh
TACACS_CONF = tacacs/priv/conf/tacacs.conf
TACACS_SYS_CONF = tacacs/priv/conf/sys.config
TACACS_ODBC_DSN = "DSN=NOC2_TEST;UID=noc2_test;PWD=noc2_test"

tacacsAPPVSN := "1.0.1"
tacacsAPPMODULES := $(notdir $(basename $(wildcard tacacs/src/*.erl)))
tacacsAPPS := kernel stdlib mnesia crypto

tacacs-all : $(TACACSRC) $(TACACS_CONF) $(TACACS_SYS_CONF)

$(TACACS_SYS_CONF): tacacs/templates/sys.config.stl
	env env TACACS_TOP=tacacs/priv ODBC_DSN=$(TACACS_ODBC_DSN) \
	$(STLFGEN) --out-file=$@ --template=$< && \
	chmod 644 $@

$(TACACSRC) : tacacs/templates/tacacsrc.sh.stl  $(STLFGEN)
	env JUNGERL_DIR=$(JUNGERL_DIR) \
		$(STLFGEN) --out-file=$@ --template=$< && \
		chmod 755 $@

$(TACACS_CONF) : tacacs/templates/tacacs.conf.stl  $(STLFGEN)
	env TACACS_TOP=tacacs/priv \
		$(STLFGEN) --out-file=$@ --template=$< && \
		chmod 600 $@

tacacs-clean :
	rm -f $(TACACSRC) $(TACACS_CONF) $(TACACS_SYS_CONF)
