%%%-------------------------------------------------------------------
%%% File    : aaa_sup.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%%
%%% Created : 15 Oct 2004 by  <svg@surnet.ru>
%%%-------------------------------------------------------------------
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(aaa.aaa_sup).

-behaviour(supervisor).
-behaviour(property_file).

-export([start_link/0]).

%% Internal exports
%% supervisor
-export([init/1]).
%% property_file
%%-export([parse_config/4, store_config/2, remove_config/1, postload_config/2]).
-export([remove_config/1, postload_config/2]).

-import(supervisor).
-import(tacacs).

-define(server, ?MODULE).

start_link() ->
  supervisor:start_link({local, ?server}, ?MODULE, []).

postload_config(_, Sup) ->
  case tacacs:is_master() of
    true ->
      %% we want to sync records only from one node
      MySup =
	{?server,
	 {?server, start_link, []},
	 permanent, infinity, supervisor, [?MODULE]
	},
      {ok, _} = supervisor:start_child(Sup, MySup);
    false ->
      ok
  end,
  ok = session:add_handler(),
  ok.

remove_config(_) ->
  session:delete_handler().

%% Server functions
init([]) ->
  MnesiaSubscriber = {odbcsync_mnesia_subscriber,
		      {aaa.odbcsync, mnesia_subscribe,[]},
		      permanent,2000,worker,[aaa.odbcsync]},
  {ok,{{one_for_one, 60, 3600}, [MnesiaSubscriber]}}.
