%%%-------------------------------------------------------------------
%%% File    : charge.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%%
%%% Created : 17 Sep 2004 by  <svg@surnet.ru>
%%%-------------------------------------------------------------------
%%
%% $Id$
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(aaa.charge).

-export([rate_session_usage/1]).

-import(lists).
-import(mnesia).
-import(wslib.log).
-import(wslib.hof).
-import(wslib.mnesiadb).

-include("aaa_schema.hrl").

rate_session_usage(Ss=#ss{record_type=RT,
			  start_time=ChargeTime,
			  se=#se{tariff_id=TariffId}
			 }) ->
  case hof:attempt(fun rate_session_usage/3, [TariffId, ChargeTime, Ss]) of
    Ret={ok, _} ->
      Ret;
    {error, Error} ->
      log:write_error("session:~p~nerror:~p~n", [Ss, Error]),
      {error, charge}
  end.

rate_session_usage(TariffId, ChargeTime, Ss) ->
  ChargeEvents = tariff:apply_tariff(TariffId, ChargeTime, Ss),
  write_ces(Ss, ChargeEvents).

write_ces(Ss=#ss{record_type=RT}, ChargeEvents) ->
  ChargeTime = erlang:localtime(),
  account:withdraw(Ss, [Ce#ce{charge_time=ChargeTime} || Ce <- ChargeEvents]).
