%%%-------------------------------------------------------------------
%%% File    : tac_session.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%%
%%% Created : 21 May 2004 by  <svg@surnet.ru>
%%%-------------------------------------------------------------------
%%
%% $Id$
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(tac_session).

-include("mnesiadb.hrl").

-export([mnesia_table_defs/0, create_tables/1]).
-export([total_counter_value/1, counter_value/1, increment_counter/1, decrement_counter/1]).

-import(wslib.mnesiadb).

-record(aaa_session_counter, {id,
			      sess_num=0
			     }).

create_tables(Nodes) ->
  mnesiadb:create_tables(Nodes, mnesia_table_defs()).

mnesia_table_defs() ->
  [?table_def(aaa_session_counter, [{local_content, true}])].

total_counter_value(User) ->
  Nodes = tacacs:where_started(),
  {Vals, _} = rpc:multicall(Nodes, ?MODULE, counter_value, [User]),
  Ret = lists:sum([0|[V || V <- Vals, is_integer(V)]]),
  Ret.

counter_value(User) ->
  case mnesia:dirty_read(aaa_session_counter, User) of
    [#aaa_session_counter{sess_num=SN}] ->
      if SN <0 -> % oops, trying to correct
	  increment_counter(User),
	  0;
	 true ->
	  SN
      end;
    _ ->
      0
  end.

increment_counter(User) ->
  mnesia:dirty_update_counter(aaa_session_counter, User, 1).

decrement_counter(User) ->
  mnesia:dirty_update_counter(aaa_session_counter, User, -1).
