#ERLC_PA +=
#ERLC_INC += -I...

EAPP_SRC += wsite/src/wsite.app.src
wsiteAPPVSN := "0.0.1"
wsiteAPPMODULES := $(notdir $(basename $(wildcard wsite/src/*.erl)))
wsiteAPPS := kernel stdlib wstl
wsiteEPACKAGES := wsite/src/wsite wsite/src/wsite/db wsite/src/wsite/form
wsiteAPPENV :=  JUNGERL_DIR=$(JUNGERL_DIR) \
		YAWS_DIR=$(YAWS_DIR) \
		TOP=$(TOP) \
		WS_DIR=$(WS_DIR) \
		STL_DIR=stl \
		WSTL_DIR=wstl \
		TEMPLATE_DIR=wsite/priv/stl

EPACKAGES += $(wsiteEPACKAGES)
ESRC += $(wildcard wsite/src/*.erl) $(wildcard $(wsiteEPACKAGES:%=%/*.erl))

WSITERC = wsite/bin/wsiterc.sh
WSITE_YAWS_BIN = wsite/bin/yaws
WSITE_YAWS_CONF = wsite/priv/conf/yaws.conf
WSITE_SYS_CONF = wsite/priv/conf/sys.config
WSTL_RUNMODS = "wstl wsite"
WSTL_APPMODS = wsite
ODBC_DSN = "DSN=NOC;UID=noc_adm;PWD="

wsite-all : $(WSITERC) $(WSITE_YAWS_CONF) $(WSITE_SYS_CONF)

$(WSITE_SYS_CONF): wsite/templates/sys.config.stl
	env ODBC_DSN=$(ODBC_DSN) \
	$(STLFGEN) --out-file=$@ --template=$< && \
	chmod 644 $@

$(WSITERC) : wsite/templates/wsiterc.sh.stl wstl/templates/wstlrc.sh.stl \
		$(WSITE_YAWS_BIN) $(STLFGEN)
	$(call wstlrc,$@,$<,$(wsiteAPPENV))

$(WSITE_YAWS_BIN): wstl/templates/yaws.stl
	$(call wstlyaws,$@,$<)

$(WSITE_YAWS_CONF) : wstl/templates/yaws.conf.stl  $(STLFGEN)
	$(call wstlyawsconf,$@,$<,$(WSTL_RUNMODS),$(WSTL_APPMODS))

wsite-clean :
	rm -f $(WSITERC) $(WSITE_YAWS_CONF) \
		$(WSITE_SYS_CONF) $(WSITE_YAWS_BIN) \
		wsite/bin/erl_crash.dump \
		wsite/bin/*.access \
		wsite/bin/*.log
