%%%-------------------------------------------------------------------
%%% File    : test_chain_dialog.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%%
%%% Created : 26 Sep 2003 by  <svg@surnet.ru>
%%%-------------------------------------------------------------------
%%
%% $Id$
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(test_chain_dialog).

-export([init/2, access_info/3, handle_event/6]).
-export([enter/4, go/4]).

-include("wstl.hrl").

%% component
access_info(_, _, _) ->
  {[do_step, do_exit], refresh}.

handle_event(Event, From,  WA, Srv, State, StateData) ->
  {next_state, ok, State, StateData}.

init(WA, _) when is_record(WA, ws_arg) ->
  StepDefs = [step1, step2, step3, step4],
  {component, wscomp.chain_dialog, {fun handler/2, [], StepDefs, WA}};
init({SN, Cnt}, _) ->
  {ok, enter, {SN, Cnt}}.

enter({inc, V}, _, _, {SN, Cnt}) ->
  {next_state, ok, [{'Step', SN}, {'Counter', Cnt+V}], go, {SN, Cnt+V}}.

go(do_step, WA, Srv, {_, Cnt}) ->
  {stop, {ok, Cnt}};
go(do_exit, _, _, S) ->
  {stop, ok};
go(_, _, _, S) ->
  {next_state, ok, go, S}.

handler(init, WA) ->
  CreateComp =
    fun (StepName, Cnt) ->
	Comp = wsdcomp:create(?MODULE, {StepName, Cnt}),
	Template = ?MODULE_STRING "_step",
	{Comp, Template}
    end,
  {ok, {CreateComp, 0}};
handler({start_dialog, StepNames}, State) ->
  io:format("step names:~p~n", [StepNames]),
  {ok, {ok, 1}, State};
handler({stop_dialog, Res}, {CC, Cnt}) ->
  io:format("result: ~p ~p~n", [Res, Cnt]),
  {ok, Res};
handler({StepName, next_step}, {CC, Cnt}) ->
  io:write({{StepName, next_step}, Cnt}),
  {ok, CC(StepName, Cnt), {inc, 1}, {CC, Cnt+1}};
handler({StepName, previous_step}, {CC, Cnt}) ->
  io:write({{StepName, previous_step}, Cnt}),
  {ok, CC(StepName, Cnt), {inc, -1}, {CC, Cnt-1}};
handler({StepName, {ok, V}}, {CC, Cnt}) ->
  io:write({StepName, V}),
  {ok, CC(StepName, Cnt), {inc, 1}, {CC, Cnt+1}}.
