%%% File    : wscontact_means_type.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created : 24 Jul 2003 by  <svg@surnet.ru>

%%
%% $Id: wscontact_means_type.erl,v 1.2 2003/09/04 17:11:36 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wscontact_means_type).

-behaviour(wsdcomp).

-export([init/2, access_info/3, handle_event/6]).

-import(wsform.search_query).

-include("wstl.hrl").

access_info(_, _, _) ->
  exit(must_never_reach).

handle_event(Event, From,  WA, Srv, State, StateData) ->
  exit(must_never_reach).

init(WA, Props) ->
  PkNames = [id, description],
  Dbh = wsdb:dbh(WA),
  Form = create_form(WA),
  MkQuery = fun (Where) ->
		wsdb_odbc:mk_select_query(contact_means_type, Where)
	    end,
  Query = search_query:mk_query(MkQuery, Form, WA,
				[{order_by_fields, [id]}]),
  Pg = {wsform.odbcdb_pager, wsdb:handler(Dbh), []},
  RowHlr = wsform.row:create_db_handler(contact_means_type),
  Rowset = wsdcomp:create(wsform.rowset, {PkNames, Form, Pg, Query}, WA, Props),
  Row = wsdcomp:create(wsform.row, {PkNames, Form, RowHlr, WA}, WA, Props),
  RowsetHook = wsform.expand_rowset_hook:create_editrow_hook(Row),
  Comp = wscomp.expand:create_comp(Rowset, RowsetHook, []),
  {component, Comp}.

%% Wsform stuff

create_form(WA) ->
  Fields = [id, description, comment],
  MkIdSel = wsite.contact_means_type:create_id_selector(id, WA, []),
  wsform:create(
    ?MODULE,
    [{label, {wsform_lib, language_label}},
     {ss,    {wsform.ss, form}}],
    Fields,
    [{data_filter,   fun data_filter/3},
     {data_type,   fun data_type/2},
     {out_attrs,   fun out_attrs/2},
     {default,     fun default/2},
     {label,       {wsform_lib, language_label}},
     {ss,          [MkIdSel(wsform_ss, WA),
		    wsform.ss:form_field(wsxmlt:m_name(Fields), WA),
		    wsxmlt:skip()]}
    ],
    WA).

data_filter(N, V, WA) when N == id; N == description ->
  wslib.str:to_upper(wsform_lib:def_data_filter(id, V, WA));
data_filter(N, V, WA) ->
  wsform_lib:def_data_filter(N, V, WA).

data_type(_Name, _WA) -> string.

default(N, WA) -> required.

out_attrs(id, _) -> [{maxlength, "64"}, {size, "32"}];
out_attrs(_, _) -> [{maxlength, "128"}, {size, "64"}].
  
