%%% File    : wsite.contact_means_type.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created :  6 Aug 2003 by  <svg@surnet.ru>

%%
%% $Id: contact_means_type.erl,v 1.3 2003/10/31 17:51:02 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsite.contact_means_type).

-export([create_id_selector/3, create_description_selector/4]).

-import(.wsdb).
-import(.wslanguage).
-import(.wscomp).
-import(.wslib).
-import(wscomp.selector).

-define(type_ids, ["TELECOM", "EMAIL"]).

create_id_selector(ValField, WA, Props) ->
  SelVals = [{K, wslanguage:msg(WA, list_to_atom(K), [])}
	     || K <- ?type_ids],
  wscomp.selector:create(
	   ValField,
	   fun (_, _) -> {ok, SelVals} end,
	   fun (_, Keys, _, _) ->
	       {stop, {ok, Keys}}
	   end,
	   [],
	   Props).

create_description_selector(Field, TypeId, WA, Props) ->
  Dbh = wsdb:dbh(WA),
  SelVals = wsdb:select_rows(Dbh, contact_means_type, [{id, TypeId}]),
  selector:create_selector(Field, description, comment, SelVals, Props).
