%%% File    : contact_means.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created :  6 Aug 2003 by  <svg@surnet.ru>

%%
%% $Id: contact_means.erl,v 1.1 2003/10/31 17:53:48 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsite.db.contact_means).

-export([insert_row/2, read_row/2, delete_row/2, update_row/2]).

-import(.wsdb).
-import(.wslib).
-import(.wslib.str).

name(Row) ->
  Type = wslib:gv(type_id, Row),
  case Type of
    "TELECOM" ->
      wslib.str:join(
	      wslib:gv_map(
		[{country_code, ""}, {area_code, ""}, contact_number], 
		Row),
	      $\s);
    "EMAIL" ->
      wslib:gv(email_address, Row)
  end.

read_row(Dbh, Pk) ->
  wsdb:read_row(Dbh, contact_means, Pk).

insert_row(Dbh, Row) ->
  Name = name(Row),
  wsdb:insert_row(Dbh, contact_means, [{name, Name}|complete_fields(Row)]).

update_row(Dbh, Row)->
  Name = name(Row),
  wsdb:update_row(Dbh, contact_means, [{name, Name}|complete_fields(Row)]).

delete_row(Dbh, Row) ->
  wsdb:delete_row(Dbh, contact_means, Row).

complete_fields(Row) ->
  Type = wslib:gv(type_id, Row),
  case Type of
    "TELECOM" ->
      [{email_address, undefined}|Row];
    "EMAIL" ->
      [{country_code, undefined},
       {area_code, undefined},
       {contact_number, undefined}|Row] 
  end.
