%%% File    : entity_type_attr.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created :  4 Dec 2002 by  <svg@surnet.ru>

%%
%% $Id: entity_type_attr.erl,v 1.4 2003/10/31 17:51:02 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsite.entity_type_attr).

-behaviour(wsdcomp).

-export([init/2, access_info/3, handle_event/6]).

-import(wslib).
-import(wsdb).
-import(wsform.rowset).
-import(wsform.row).
-import(wsdcomp).
-import(stl_yaws).
-import(wsdb_odbc).
-import(lists).
-import(wsform_lib).
-import(wsform).
-import(wsform.search_query).
-import(odbcdb).

-include("wstl.hrl").

access_info(_, _, _) ->
  exit(must_never_reach).

handle_event(Event, From,  WA, Srv, State, StateData) ->
  exit(must_never_reach).
  
init({WA, TableName, FkN, FkV}, Props) ->
  PkNames = [FkN, attr_name],
  Fk = {FkN, FkV},
  Dbh = wsdb:dbh(WA),
  Form = create_form(TableName, WA),
  MkQuery = fun (Where) ->
		Q = wsdb_odbc:mk_select_query(TableName, [FkN|Where]),
		fun (P, Cont) ->
		    Q([Fk|P], Cont)
		end
	    end,
  Query = search_query:mk_query(MkQuery, Form, WA, [{order_by_fields, [FkN]}]),
  Pg = {wsform.odbcdb_pager, wsdb:handler(Dbh), []},
  RowHlr = create_row_handler(TableName, [Fk]),
  Rowset = wsdcomp:create(wsform.rowset, {PkNames, Form, Pg, Query}, WA, Props),
  Row = wsdcomp:create(wsform.row, {PkNames, Form, RowHlr, WA}, WA, Props),
  RowsetHook =
    wsform.expand_rowset_hook:create_editrow_hook(
	     Row,
	     [{rowset_events, [do_add_row, do_view_row, do_delete_row]}]),
  Comp = wscomp.expand:create_comp(Rowset, RowsetHook, []),
  {component, Comp}.

%% Row stuff
create_row_handler(TableName, Params) ->
  RowHlr = wsform.row:create_db_handler(TableName),
  fun ({Op, Row}, Dbh) ->
      RowHlr({Op, Params++Row}, Dbh)
  end.

%% Wsform stuff

create_form(TableName, WA) ->
      wsform:create(TableName,
		    [],
		    [attr_name],
		    [
		     {data_type,   fun data_type/2},
		     {out_attrs,   fun out_attrs/2},
		     {default,     fun default/2},
		     {label,       {wsform_lib, language_label}}
		    ],
		    WA).

data_type(attr_name, _) -> atom;
data_type(_, _) -> string.
  
default(_, _) -> required.

out_attrs(_, _) -> [{maxlength, "64"}, {size, "32"}].

