%%% File    : entity_type.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created :  7 Sep 2003 by  <svg@surnet.ru>

%%
%% $Id: entity_type.erl,v 1.1 2003/10/31 17:53:48 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsite.form.entity_type).

-export([create/3, create/4, create_selector/6]).

-import(wsform).
-import(wsform_lib).
-import(wslib).
-import(wsdb).
-import(wscomp.selector).

-include("wstl.hrl").


create_selector(FieldName, TableName, PkField, DescField, WA, Props) ->
  Dbh = wsdb:dbh(WA),
  Rows = wsdb:select_rows(Dbh, TableName, [], [PkField]), 
  selector:create_selector(FieldName, PkField, DescField, Rows, Props).

create(EntityName, PkName, WA) ->
  create(EntityName, PkName, WA, []).

create(EntityName, PkName, WA, Props) ->
  PkFilter =
    case wslib:gv(primary_key_case, Props, upper) of
      upper ->
	to_upper;
      lower ->
	to_lower
    end,

  wsform:create(EntityName,
		[],
		[PkName, has_table, description, form],
		[{data_filter, data_filter(PkName, PkFilter)},
		 {data_type,   data_type(PkName)},
		 {out_attrs,   out_attrs(PkName)},
		 {default,     default(PkName)},
		 {label,       {wsform_lib, language_label}}
		],
		WA).

data_filter(PN, PF) ->
  fun (K, V, WA) when K == PN -> 
      wslib.str:PF(wsform_lib:def_data_filter(K, V, WA));
      (K, V, WA) -> 
      wsform_lib:def_data_filter(K, V, WA)
  end.

data_type(PN) ->
  fun (K, _) when K == PN -> string;
      (has_table, _)      -> boolean;
      (description, _)    -> string;
      (form, _)           -> atom
  end.
  
default (PN) ->
  fun (K, _) when K == PN -> required;
      (has_table, _) -> false;
      (N, WA)        -> wsform_lib:def_value(N, WA)
  end.

out_attrs(PN) ->
  fun (K, _) when K == PN -> [{maxlength, "64"}, {size, "32"}];
      (form, _)        -> [{maxlength, "64"}, {size, "32"}];
      (description, _) -> [{maxlength, "128"}, {size, "64"}];
      (_, _) -> []
  end.
