%%% File    : field.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created : 17 Oct 2004 by  <svg@surnet.ru>

%%
%% $Id$
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsite.form.field).

-export([data_type/2, default/2, ss/2, validate/4, out_attrs/2]).

-import(lists).
-import(wscomp.selector).
-import(wslanguage).

-define(status_values, [created, open, closed, reserved, suspended]).


data_type(status, _) ->
  atom;
data_type(currency_type_id, _) ->
  atom;
data_type(charge_type_id, _) ->
  atom;
data_type(tariff_id, _) ->
  integer.

default(status, _) -> 
  created;
default(tariff_id, _) ->
  undefined.

validate(status, V, _KVs, _WA) ->
  lists:member(V, ?status_values);
validate(_, _, _, _) ->
  true.

ss(status, WA) ->
  KVs = [[{id, K}, {description, wslanguage:msg(WA, K, [])}]
	 || K <- ?status_values],
  (selector:create_selector(status, id, description, KVs, []))(wsform_ss, WA);
ss(tariff_id, WA) ->
  MkSelector = wsite.form.entity_type
    :create_selector(tariff_id, tariff, id, description, WA, []),
  MkSelector(wsform_ss, WA);
ss(charge_type_id, WA) ->
  MkSelector = wsite.form.entity_type
    :create_selector(charge_type_id, charge_type, id, description, WA, []),
  MkSelector(wsform_ss, WA);
ss(currency_type_id, WA) ->
  MkSelector = wsite.form.entity_type
    :create_selector(currency_type_id, currency_type, id, description, WA, []),
  MkSelector(wsform_ss, WA);
ss(service_type_id, WA) ->
  MkServiceTypeSel = wsite.form.entity_type
    :create_selector(service_type_id, service_type, id, description, WA, []),
  MkServiceTypeSel(wsform_ss, WA).

out_attrs(_, _) ->
  [].
