%%% File    : party.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created :  6 Sep 2003 by  <svg@surnet.ru>

%%
%% $Id: party.erl,v 1.1 2003/10/31 17:53:48 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsite.form.party).

-export([create/3]).

-import(wsdb).
-import(wsform).
-import(wsform.ss).
-import(lists).
-import(wsite.form.entity_type).
-import(wsxmlt).

-include("wstl.hrl").

create(Label, EntityFields, WA) ->
  Fields = case lists:member(id, EntityFields) of
	     true -> EntityFields;
	     false ->[id|EntityFields]
	   end,
  wsform:create(
    party,
    [{label, fun (_, _) -> Label end}],
    Fields,
    [
     {data_type,   fun data_type/2},
     {out_attrs,   fun out_attrs/2},
     {default,     fun default/2},
     {label,       {wsform_lib, language_label}},
     {ss,          ss(Fields, WA)}
    ],
    WA).

data_type(id, _)   -> integer;
data_type(name, _) -> string;
data_type(party_type_id, _) -> string.
  
default(id, _) ->
  fun (WA) ->
      Dbh = wsdb:dbh(WA),
      wsdb:next_rowid(Dbh, party)
  end;
default(name, _) -> required;
default(party_type_id, _) -> required.

out_attrs(id, _)      -> [{maxlength, "16"}, {size, "8"}];
out_attrs(name, _)    -> [{maxlength, "128"}, {size, "64"}];
out_attrs(party_type_id, _) -> [{maxlength, "128"}, {size, "64"}].

ss(Fields, WA) ->
  Ss = [ss:form_field(wsxmlt:m_name(Fields), WA)],
  case lists:member(party_type_id, Fields) of
    true ->
      Sel = entity_type:
	create_selector(party_type_id, party_type, id, description, WA, []),
      [Sel(wsform_ss, WA)|Ss];
    false ->
      Ss
  end.


