%%% File    : postal_address.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created :  6 Sep 2003 by  <svg@surnet.ru>

%%
%% $Id: postal_address.erl,v 1.1 2003/10/31 17:53:48 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsite.form.postal_address).

-export([create/1]).

-import(.wsdb).
-import(.wsform).
-import(.wsform_lib).
-import(.wsxmlt).


-include("wstl.hrl").

create(WA) ->
  Fields =
    [id,
     city,
     address1,
     address2,
     postal_code
    ],
  wsform:create(
    postal_address,
    [{label, {wsform_lib, language_label}}],
    Fields,
    [
     {data_type,   fun data_type/2},
     {out_attrs,   fun out_attrs/2},
     {default,     fun default/2},
     {label,       {wsform_lib, language_label}},
     {ss,          [wsform.ss:form_field(wsxmlt:m_name(Fields), WA),
		    wsxmlt:skip()]}
    ],
    WA).

data_type(id, _)       -> integer;
data_type(_, _)        -> string.
  
default(id, _) ->
  fun (WA) ->
      Dbh = wsdb:dbh(WA),
      wsdb:next_rowid(Dbh, postal_address)
  end;
default(N, WA) -> wsform_lib:def_value(N, WA).

out_attrs(id, _) -> [{maxlength, "16"}, {size, "8"}];
out_attrs(postal_code, _) -> [{maxlength, "20"}, {size, "8"}];
out_attrs(_, _) -> [{maxlength, "128"}, {size, "64"}].
