%%% File    : party_person.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created : 24 Jul 2003 by  <svg@surnet.ru>

%%
%% $Id: party_person.erl,v 1.3 2003/09/05 20:33:18 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsite.party_person).

-export([read_row/2, insert_row/2, delete_row/2, update_row/2]).

-import(.wslib).
-import(.wsdb).
-import(.lists).

-include("wstl.hrl").

-define(party_type, "PERSON").

read_row(Dbh, Pk) ->
  wsdb:read_row(Dbh, person, 
		[{party_id, wslib:gv(party_id, Pk, wslib:gv(id, Pk))}]).

insert_row(Dbh, Row) ->
  Fun =
    fun (Db) ->
	Party = [{party_type_id, ?party_type},
		 {id, wslib:gv(party_id, Row)},
		 get_party_name_kv(Row)],
	
	{ok, _} = wsdb:insert_row(Db, party, Party),
	wsdb:insert_row(Db, person, Row)
    end,
  wsdb:transaction(Dbh, Fun).

update_row(Dbh, Row)->
  Fun =
    fun (Db) ->
	Party = [{party_type_id, ?party_type},
		 {id, wslib:gv(party_id, Row)},
		 get_party_name_kv(Row)],
	{ok, _} = wsdb:update_row(Db, party, Party),
	wsdb:update_row(Dbh, person, Row)
    end,
  wsdb:transaction(Dbh, Fun).

delete_row(Dbh, Row) ->
  Fun =
    fun (Db) ->
	{ok, _} = wsdb:delete_row(Db, person, Row),
	wsite.party:delete_row(Db, party, [{id, wslib:gv(party_id, Row)}])
    end,
  wsdb:transaction(Dbh, Fun).

get_party_name_kv(Row) ->
  PartyName = wslib.str:
    join(wslib:gv_map([{last_name, ""}, {first_name, ""}], Row), $\s),
  {name, PartyName}.
