%%% File    : party_relationship_type.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created : 24 Jul 2003 by  <svg@surnet.ru>

%%
%% $Id: party_relationship_type.erl,v 1.3 2003/10/31 17:51:02 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsite.party_relationship_type).

-export([select_rows/3, create_selector/6]).

-import(wslib).
-import(wslib.str).
-import(wsdb).
-import(lists).
-import(wscomp.selector).

select_rows(Direction, PartyId, WA) ->
  FieldName =
    case Direction of
      to ->
	role_type_id_to_valid;
      from ->
	role_type_id_from_valid
    end,
  Dbh = wsdb:dbh(WA),
  PartyRoles = [wslib:gv(role_type_id, Row)
		|| Row <- wsdb:select_rows(Dbh, party_role,
					   [{party_id, PartyId}])],
  wsdb:select_rows(
    Dbh, party_relationship_type, [{in, FieldName, PartyRoles}]).

create_selector(Direction, FieldName, {party_id, PartyId}, Test, WA, Props) ->
  Rowset =
    [Row || Row <- select_rows(Direction, PartyId, WA), Test(Row) == true],
  selector:create_selector(FieldName, id, description, Rowset, Props).
