%%%----------------------------------------------------------------------
%%% File    : wsite_sup.erl
%%% Author  :  <svg@surnet.ru>
%%% Purpose : 
%%% Created :  3 Oct 2001 by  <svg@surnet.ru>
%%%----------------------------------------------------------------------

-module(wsite_sup).
-vsn('$Id: wsite_sup.erl,v 1.1 2003/09/01 15:18:40 vsekissov Exp $.').
-author('svg@surnet.ru').

-behaviour(application).
-behaviour(supervisor).

%% Supervisor exports
-export([start_link/0]).

%% application callbacks
-export([start/2, stop/1, config_change/3]).

%% supervisor callbacks
-export([init/1]).

-import(wslib.getopt).

-define(appname, wsite).
-define(appsuper, ?MODULE).
-define(super_spec, {one_for_one, 4, 3600}).

%%%----------------------------------------------------------------------
%%% API
%%%----------------------------------------------------------------------
start_link() ->
  supervisor:start_link({local, ?appsuper}, ?appsuper, []).

%%%----------------------------------------------------------------------
%%% Callback functions from application
%%%----------------------------------------------------------------------

%%----------------------------------------------------------------------
%% Func: start/2
%% Returns: {ok, Pid}        |
%%          {ok, Pid, State} |
%%          {error, Reason}   
%%----------------------------------------------------------------------

start(Type, StartArgs) ->
  start_link().

config_change(Changed, New, Removed) ->
  ok.

%%----------------------------------------------------------------------
%% Func: stop/1
%% Returns: any 
%%----------------------------------------------------------------------
stop(State) ->
  ok.

%%%----------------------------------------------------------------------
%%% Callback functions from supervisor
%%%----------------------------------------------------------------------

%%----------------------------------------------------------------------
%% Func: init/1
%% Returns: {ok,  {SupFlags,  [ChildSpec]}} |
%%          ignore                          |
%%          {error, Reason}   
%%----------------------------------------------------------------------
init([]) ->
  {ok,{?super_spec, []}}.

%%%----------------------------------------------------------------------
%%% Internal functions
%%%----------------------------------------------------------------------
