%%% File    : wsleasedline_sia.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created :  4 Dec 2002 by  <svg@surnet.ru>

%%
%% $Id: wsleasedline_sia.erl,v 1.2 2003/09/04 17:11:37 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsleasedline_sia).

-behaviour(wsdcomp).

-export([init/2, access_info/3, handle_event/6]).

-import(wsform.search_query).

-include("wstl.hrl").

-define(table, leasedline_attr).

access_info(_, _, _) ->
  exit(must_never_reach).

handle_event(Event, From,  WA, Srv, State, StateData) ->
  exit(must_never_reach).


init(WA, Props) ->
  PkNames = [source_informer_address],
  Dbh = wsdb:dbh(WA),
  Form = create_form(WA),
  FormType = wslib:gv(form_type, Props, table),
  Row = 
    if (FormType =/= rowset) ->
	RowHlr = wsform.row:create_db_handler(?table),
	wsdcomp:create(wsform.row, {PkNames, Form, RowHlr, WA}, WA, []);
       true ->
	undefined
    end,
  Rowset =
    if (FormType =/= row) ->
	MkQuery = fun (Where) ->
		      wsdb_odbc:mk_select_query(?table, Where)
		  end,
	Query = search_query:mk_query(MkQuery, Form, WA,
					     [{order_by_fields, PkNames}]),
	Pg = {wsform.odbcdb_pager, wsdb:handler(Dbh), []},
	wsdcomp:create(wsform.rowset, {PkNames, Form, Pg, Query}, WA, Props);
       true ->
	undefined
    end,
  case FormType of
    row ->
      {component, Row};
    rowset ->
      {component, Rowset};
    table ->
      RowsetHook = wsform.expand_rowset_hook:create_editrow_hook(Row),
      Comp = wscomp.expand:create_comp(Rowset, RowsetHook, []),
      {component, Comp}
  end.

create_form(WA) ->
  Fields =
    [source_informer_address,
     last_stat_date,
     period,
     community,
     device_ident,
     checkpoint,
     device_counter_max
    ],
  wsform:create(
    leasedline_sia,
    [{label, {wsform_lib, language_label}}],
    Fields,
    [
     {data_type,   fun data_type/2},
     {out_attrs,   fun out_attrs/2},
     {default,     fun default/2},
     {label,       {wsform_lib, language_label}},
     {ss,          [wsform.ss:form_field(wsxmlt:m_name(Fields), WA),
		    wsxmlt:skip()]}
    ],
    WA).

data_type(checkpoint, _) -> integer;
data_type(device_counter_max, _) -> integer;
data_type(last_stat_date, _) -> datetime;
data_type(period, _) -> time;
data_type(_, _) -> string.

default(source_informer_address, _) ->
  required;
default(period, _) ->
  {0, 5, 0};
default(N, WA) -> wsform_lib:def_value(N, WA).

out_attrs(_, _) -> [{maxlength, "128"}, {size, "64"}].
