%%% File    : wsparty_role.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created :  4 Dec 2002 by  <svg@surnet.ru>

%%
%% $Id: wsparty_role.erl,v 1.1 2003/09/01 15:18:40 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsparty_role).

-behaviour(wsdcomp).

-export([init/2, access_info/3, handle_event/6]).

-include("wstl.hrl").

access_info(_, _, _) ->
  exit(must_never_reach).

handle_event(Event, From,  WA, Srv, State, StateData) ->
  exit(must_never_reach).
  
init({Id, WA}, Props) ->
  PartyId = [{party_id, Id}],
  Label = {label, party_role},
  {component,
   wsdcomp:create(
     wscomp.add_delete_selector,
     {fun add_roles/3,
      fun select_add_roles/2,
      fun delete_roles/3,
      fun select_del_roles/2,
      PartyId,
      WA
     },
     WA,
     [Label|Props]
    )
  }.

add_roles(Ps, WA, Params) ->
  Dbh = wsdb:dbh(WA),
  lists:foreach(fun (P) ->
		    {ok, _} = add_role(Dbh, P, Params)
		end, Ps).

add_role(Dbh, RoleId, Params) ->
  wsdb:insert_row(Dbh, party_role, [{role_type_id, RoleId}|Params]).

select_add_roles(WA, Params) ->
  Dbh = wsdb:dbh(WA),
  Rows = [selector_kv(Row)
	  || Row <- wsdb:do(Dbh, select,['PARTY_ROLE_NOT_IN_PARTY', Params])],
  {ok, Rows}.

delete_roles(Ps, WA, Params) ->
  Dbh = wsdb:dbh(WA),
  lists:foreach(fun (P) ->
		    {ok, _} = delete_role(Dbh, P, Params)
		end, Ps).

delete_role(Dbh, RoleId, Params) ->
  wsdb:delete_row(Dbh, party_role, [{role_type_id, RoleId}|Params]).

select_del_roles(WA, Params) ->
  Dbh = wsdb:dbh(WA),
  Rows = [selector_kv(Row)
	  || Row <- wsdb:do(Dbh,select,['PARTY_ROLE', Params])],
  {ok, Rows}.

selector_kv(Row) ->
  Id = wslib:gv(id, Row),
  Desc =  wslib:gv(description, Row),
  {Id, io_lib:format("~s - ~s", [Id, Desc])}.
