%%% File    : wspostal_address.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created :  4 Dec 2002 by  <svg@surnet.ru>

%%
%% $Id: wspostal_address.erl,v 1.2 2003/09/04 17:11:37 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wspostal_address).

-behaviour(wsdcomp).

-export([init/2, access_info/3, handle_event/6]).

-import(wsform.search_query).

-include("wstl.hrl").

access_info(_, _, _) ->
  exit(must_never_reach).

handle_event(Event, From,  WA, Srv, State, StateData) ->
  exit(must_never_reach).


init(WA, Props) ->
  PkNames = [id],
  Dbh = wsdb:dbh(WA),
  Form = wsite.form.postal_address:create(WA),
  FormType = wslib:gv(form_type, Props, table),
  Row = 
    if (FormType =/= rowset) ->
	RowHlr = wsform.row:create_db_handler(postal_address),
	wsdcomp:create(wsform.row, {PkNames, Form, RowHlr, WA}, WA, []);
       true ->
	undefined
    end,
  Rowset =
    if (FormType =/= row) ->
	MkQuery = fun (Where) ->
		      wsdb_odbc:mk_select_query(postal_address, Where)
		  end,
	Query = search_query:mk_query(MkQuery, Form, WA,
					     [{order_by_fields, [id]}]),
	Pg = {wsform.odbcdb_pager, wsdb:handler(Dbh), []},
	wsdcomp:create(wsform.rowset, {PkNames, Form, Pg, Query}, WA, Props);
       true ->
	undefined
    end,
  case FormType of
    row ->
      {component, Row};
    rowset ->
      {component, Rowset};
    table ->
      RowsetHook = wsform.expand_rowset_hook:create_editrow_hook(Row),
      Comp = wscomp.expand:create_comp(Rowset, RowsetHook, []),
      {component, Comp}
  end.
