%%% File    : wsrole_types.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created :  4 Dec 2002 by  <svg@surnet.ru>

%%
%% $Id: wsrole_types.erl,v 1.2 2003/09/05 19:08:37 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsrole_types).

-behaviour(wsdcomp).

-export([init/2, access_info/3, handle_event/6]).
-export([enter/4, selector_return/4]).

-import(wscomp.selector).

-include("wstl.hrl").

-define(role_tables, [{role_type,
		       [role_type,
			id,
			role_type_attr,
			role_type_id]},
		      {location_role_type,
		       [location_role_type,
			id,
			location_role_type_attr,
			location_role_type_id]},
		      {contact_mech_role_type,
		       [contact_mech_role_type,
			id,
			contact_mech_role_type_attr,
			contact_mech_role_type_id]}
		     ]).

access_info(_, _, _) -> #access_info{events=[], default_event=refresh}.

handle_event(Event, security_alert, WA, Srv, State, StateData) ->
  {stop, ok};
handle_event(Event, From,  WA, Srv, State, StateData) ->
  {next_state, ok, State, StateData}.
  
init(WA, _) ->
  {ok, enter, ?role_tables}.

enter(_, WA, Srv, Tables) ->
  SelList = [{T, Label=wslanguage:msg(WA, T, [])} || {T, _} <- Tables],
  GetValues = fun (_, _) -> {ok, SelList} end,
  OnSelect = fun (Event, [T], _, _) -> 
		 {stop, {Event, wslib:gv(list_to_atom(T), Tables)}}
	     end,
  Data = [],
  Render = stl_yaws:create_screen1(WA, "lib/button_selector"),
  Props = [{render, Render},
	   {label, wslanguage:msg(WA, 'CHOOSE_VALUE', [])},
	   {selector_attrs,
	    [{orientation, horizontal}]}
	  ],
  MkSelector = selector:create(id, GetValues, OnSelect, Data, Props),
  {call_exec, enter, MkSelector(component, WA), selector_return, []}.

selector_return({do_select, [TableName, PkName, AttrTableName, AttrFk]},
		WA, Srv, _) ->
  Comp = wsdcomp:create(wsite.entity_type, 
			{WA, TableName, PkName, AttrTableName, AttrFk},
			WA,
			[{template, "wsrole/types"}]
		       ),
  {exec, enter, Comp};
selector_return(Ret, _, _, _) ->
  {stop, ok}.

