%%% File    : wuser_login_security_group.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created :  4 Dec 2002 by  <svg@surnet.ru>

%%
%% $Id: wsuser_login_security_group.erl,v 1.1 2003/10/31 17:54:50 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsuser_login_security_group).

-behaviour(wsdcomp).

-export([init/2, access_info/3, handle_event/6]).

-include("wstl.hrl").

access_info(_, _, _) ->
  exit(must_never_reach).

handle_event(Event, From,  WA, Srv, State, StateData) ->
  exit(must_never_reach).
  
init(Arg={Id, WA}, Props) ->
  LoginId = {login_id, Id},
  Comp = wsdcomp:create(
	   wscomp.add_delete_selector,
	   {fun add_groups/3,
	    fun select_add_groups/2,
	    fun delete_groups/3,
	    fun select_del_groups/2,
	    [LoginId],
	    WA
	   },
	   WA,
	   Props ++ [{label, ?MODULE}]
	  ),
  {component, Comp}.

add_groups(Ps, WA, Params) ->
  Dbh = wsdb:dbh(WA),
  lists:foreach(fun (P) ->
		    {ok, _} = add_group(Dbh, P, Params)
		end, Ps).

add_group(Dbh, GroupId, Params) ->
  wsdb:insert_row(Dbh, user_login_security_group,
		  [{group_id, GroupId}|Params]).

select_add_groups(WA, Params) ->
  Dbh = wsdb:dbh(WA),
  Rows = [selector_kv(Row)
	  || Row <- wsdb:do(Dbh,select,['SECURITY_GROUP_NOT_IN_USER_LOGIN', Params])],
  {ok, Rows}.

delete_groups(Ps, WA, Params) ->
  Dbh = wsdb:dbh(WA),
  lists:foreach(fun (P) ->
		    {ok, _} = delete_group(Dbh, P, Params)
		end, Ps).

delete_group(Dbh, GroupId, Params) ->
  wsdb:delete_row(Dbh, user_login_security_group,
		  [{group_id, GroupId}|Params]).

select_del_groups(WA, Params) ->
  Dbh = wsdb:dbh(WA),
  Rows = [selector_kv(Row)
	  || Row <- wsdb:do(Dbh,select,['SECURITY_GROUP_IN_USER_LOGIN', Params])],
  {ok, Rows}.

selector_kv(Row) ->
  Id = wslib:gv(id, Row),
  Desc =  wslib:gv(comment, Row),
  {Id, io_lib:format("~s - ~s", [Id, Desc])}.
