%%
%% $Id: log.erl,v 1.1 2003/08/29 13:51:26 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wslib.log).

-export([write_error/2, write_info/2, fmt/2]).

-import(application).
-import(error_logger).
-import(wslib.misc).
-import(wslib.str).

-define(unknown, '?').

write_error(Format, Args) ->
  error_logger:error_report(fmt(Format, Args)).

write_info(Format, Args) ->
  error_logger:info_report(fmt(Format, Args)).

fmt(Fmt, Args) ->
  %% derived from jungerl/lib/ce/src/ce_log.erl
  {Module, Function, Arity} =
    case misc:call_stack() of
      [_, _, Head | _] ->
	Head;
      _ ->
	{?unknown, ?unknown, ?unknown}
    end,
  App =
    case application:get_application() of
      {ok, A} ->
	A;
      _ ->
	?unknown
    end,
  str:fmt("~s [~s:~s/~w] "++Fmt, [App, Module, Function, Arity]++Args).
