RDBMS_DIR = $(JUNGERL_DIR)/lib/rdbms
ERLC_INC += -I$(RDBMS_DIR)/include -I$(YAWS_DIR)/include
EPACKAGES += wstl/src/wscomp wstl/src/wsform
ESRC += $(wildcard wstl/src/*.erl) \
	$(wildcard wstl/src/wscomp/*.erl) \
	$(wildcard wstl/src/wsform/*.erl)
EPACKAGES += wstl/src/wscomp  wstl/src/wsform
EAPP_SRC += wstl/src/wstl.app.src
wstlAPPVSN := "0.0.1"
wstlAPPMODULES := $(notdir $(basename $(wildcard wstl/src/*.erl)))
wstlAPPS := kernel stdlib

STL_DIR = stl
WSTLRC = wstl/bin/wstlrc.sh
WSTL_YAWS_CONF = wstl/priv/conf/yaws.conf
WSTL_RUNMODS = wstl
WSTL_APPMODS = wstl
WSTL_YAWS_BIN = wstl/bin/yaws

wstlrc = env JUNGERL_DIR=$(JUNGERL_DIR) \
		YAWS_DIR=$(YAWS_DIR) \
		WS_DIR=$(WS_DIR) \
		$(3) \
		$(STLFGEN) --out-file=$(1) --template=$(2) && \
		chmod 755 $(1)

wstlyawsconf = env JUNGERL_DIR=$(JUNGERL_DIR) \
		YAWS_DIR=$(YAWS_DIR) \
		TOP=$(TOP) \
		STL_DIR=$(STL_DIR) \
		RUNMODS=$(3) \
		APPMODS=$(4) \
		$(STLFGEN) --out-file=$(1) --template=$(2) && \
		chmod 644 $(1)

wstlyaws = env ERL=$(ERL) \
		YAWS_DIR=$(YAWS_DIR) \
		$(STLFGEN) --out-file=$(1) --template=$(2) && \
		chmod 755 $(1)

wstl-all: $(WSTLRC) $(WSTL_YAWS_CONF)

wstl-clean :
	rm -f $(WSTLRC) $(WSTL_YAWS_CONF) $(WSTL_YAWS_BIN)

$(WSTL_YAWS_BIN): wstl/templates/yaws.stl
	$(call wstlyaws,$@,$<)

$(WSTLRC): wstl/templates/wstlrc.sh.stl  $(WSTL_YAWS_BIN) $(STLFGEN)
	$(call wstlrc,$@,$<)

$(WSTL_YAWS_CONF): wstl/templates/yaws.conf.stl  $(STLFGEN)
	$(call wstlyawsconf,$@,$<,$(WSTL_RUNMODS),$(WSTL_APPMODS))
