%%
%% $Id: wsauthen.erl,v 1.3 2003/10/31 17:57:31 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsauthen).

-export([create/4]).

-include("wstl.hrl").

create(Path, WA, Comp, Event) ->
  DataComp = create_comp(fun enter/3, {Path, WA, Comp, Event}),
  wsvcomp:create("authenticate", [], DataComp, wslib:mk_dummy_render([])).

enter({call, do, WA}, Cont, State) ->
  Render = stl_yaws:create_page(
	     WA,
	     stl_yaws:create_screen(WA, "wslogin",
				    stl_yaws:screen_place_at())),
  #comp{dcomp=D, render=R} =
    wsdcomp:create(wslogin, WA, Render, [{secure, false}]),
  Cont({call_exec, D, R, {login, "", ""},
	create_comp(fun login_return/3, State)}).

login_return({answer, exec, Answer, WA}, Cont,
	     {AuthPath, AuthWA, AuthComp, AuthEvent}) ->
  WA0 = WA#ws_arg{yaws_arg=AuthWA#ws_arg.yaws_arg},
  case Answer of
    ok ->
      ReqPath =
	case AuthPath of
	  [] ->
	    AuthComp(name);
	  _ ->
	    AuthPath
	end,
      Cont({exec, AuthComp, {call, {user_req, ReqPath}, AuthPath, WA0}});
    Error ->
      wslib:show_lerror(permission_denied, [], WA),
      Cont({exec, AuthComp,
	    {call, wsdcomp:security_alert(AuthEvent), AuthPath, WA0}})
  end.

create_comp(State, StateData) ->
  fun (Msg) ->
      fun (Cont) ->
	  State(Msg, Cont, StateData)
      end
  end.
