%%% File    : wscomp.choose.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : Exec or call_exec component handler returns 
%%% Created :  4 Dec 2002 by  <svg@surnet.ru>

%%
%% $Id: choose.erl,v 1.1 2003/10/27 16:45:04 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wscomp.choose).

-behaviour(wsdcomp).

-export([create/2]).

-export([init/2, access_info/3, handle_event/6]).
-export([enter/4, go/4]).

-import(wslib).
-import(wsdcomp).

-include("wstl.hrl").

-record(state, {handler, hdata}).

create(Handler, HandlerArg) ->
  wsdcomp:create(?MODULE, {Handler, HandlerArg},
		 wslib:mk_dummy_render([]), []). 
%%
%% Handler(init, Data) -> {ok, State};
%%        ({call, UserEvent, WA, Srv}, State) -> {exec, Event, Comp}
%%                                       | {call_exec, Event, Comp, NextState}
%%                                       | {stop, Return}
%% UserEvent = Event = Data = Msg = State = NextState = term()
%% WA = ws_arg()
%% Srv = pid()
%% Comp = component()
%%                            
access_info(_, _, _) ->
  exit(must_never_reach).

handle_event(Event, From,  WA, Srv, State, StateData) ->
  exit(must_never_reach).

%%
%% init({Handler, HandlerArg, WA}, Props) ->
%%    {ok, StartStateName, StateData}
%%
%% Handler = function()
%% HandlerArg = term()
%% WA = ws_arg()
%% Props = [{K::atom(), V::term()}]
%%
init({Handler, HandlerArg}, _Props) ->
  {ok, HD} = Handler(init, HandlerArg),
  {ok, enter, #state{handler=Handler, hdata=HD}}.

enter(Event, WA, Srv, State) ->
  go(Event, WA, Srv, State).

go(UserEvent, WA, Srv, S=#state{handler=H, hdata=HD}) ->
  case H({call, UserEvent, WA, Srv}, HD) of
    {call_exec, Event, Comp, NxtHD} ->
      {call_exec, Event, Comp, go, S#state{hdata=NxtHD}};
    Exec={exec, _, _} ->
      Exec;
    Stop={stop, _} ->
      Stop
  end.
