%%% File    : wsdbg.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created : 28 Jul 2003 by  <svg@surnet.ru>

%%
%% $Id: wsdbg.erl,v 1.2 2003/10/31 17:57:31 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsdbg).

-export([start/0, stop/0, log/2, info/1, add_level/2, del_level/1]).

-import(wslib.dbg_srv).

start() ->
  Ret =
    case whereis(dbg_srv) of
      undefined ->
	{ok, _} = dbg_srv:start([]);
      Pid ->
	{ok, Pid}
    end,
  [dbg_srv:add_level(Lvl, Modules) || {Lvl, Modules} <- lvls()],
  Ret.

stop() ->
  wslib.dbg_srv:stop().

log(Lvl, Flag) ->
  wslib.dbg_srv:log(Lvl, Flag).

add_level(Level, Modules) ->
  wslib.dbg_srv:add_level(Level, Modules).

del_level(Level) ->
  wslib.dbg_srv:del_level(Level).

info(level) ->
  wslib.dbg_srv:info(level).

lvls() ->
  [{render, [stl_yaws]},
   {component, [wsvcomp, wsdcomp]},
   {expandcomponent, ['wscomp.expand']},
   {form, [wsfrom, wsform_lib]},
   {acl, [wsacl]},
   {db, [odbcdb]}
  ].
