%%%-------------------------------------------------------------------
%%% File    : edit_relationship.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%%
%%% Created : 30 Sep 2003 by  <svg@surnet.ru>
%%%-------------------------------------------------------------------
%%
%% $Id: edit_relationship.erl,v 1.1 2003/10/27 16:45:04 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsform.edit_relationship).

-behaviour(wsdcomp).

-export([init/2, access_info/3, handle_event/6]).
-export([enter/4, detail_rowid/4]).

-import(wsdcomp).
-import(wslib).

access_info(_, _, _) ->
  exit(must_never_reach).

handle_event(Event, From,  WA, Srv, State, StateData) ->
  exit(must_never_reach).

%% Action = do_select | do_create
%% 
%% MkDetailComp(FormType, Data, WA) -> {ok, Comp, DetStartEvent} | {ok, Comp}
%% 
%% FormType = row | rowset
%% 
%% DetStartEvent = term() | DefaultStartEvent
%% 
%% DetDefaultStartEvent = {create_row, []} | enter
%% 
%% MkMasterComp(Event, DetailRowId, Data, WA)
%%    -> {ok, Comp, MasterStartEvent} | {ok, Comp}
%%    
%% Event = create_row | term()
%% 
%% MasterStartEvent = term() | MasterDefaultStartEvent
%% 
%% MasterDefaultStartEvent = {create_row, []}
%%    
%% Relationship = [{MasterKey::atom(), DetailKey::atom()}]
%% 
%% Data = term()
%% 
%% WA = ws_arg()
%% 
init({Action, MkDetailComp, MkMasterComp, Relationship, Data, WA}, _) ->
  {Mode, DetailComp, DetailEvent} =
    case Action of
      do_select ->
	{Rowset, Event} =
	  fmt_mk_ret(MkDetailComp(select_row, Data, WA), enter),
	RowsetHook = expand_rowset_hook:create_select_rowid_hook(),
	Rowset1 = wscomp.expand:create_comp(Rowset, RowsetHook, []),
	{create, Rowset1, Event};
      do_create ->
	{Row, Event} =
	  fmt_mk_ret(MkDetailComp(create_row, Data, WA), {create_row, []}),
	{create, Row, Event};
      view_details ->
	DetailRowid = [{FKey, wslib:gv(PKey, Data)}
		       || {PKey, FKey} <- Relationship],
	{Row, Event} =
	  fmt_mk_ret(MkDetailComp(view_row, DetailRowid, WA),
		     {do_view_row, DetailRowid}),
	{view, Row, Event}
    end,
  {ok, enter,
   {Mode, DetailEvent, DetailComp, MkMasterComp, Relationship, Data}}.

enter(_, WA, Srv, {view, Event, DetailComp, _, _, _}) ->
  {exec, Event, DetailComp};
enter(_, WA, Srv, {_, Event, DetailComp, MkMasterComp, Relationship, Data}) ->
  {call_exec, Event, DetailComp,
   detail_rowid, {MkMasterComp, Relationship, Data}}.

detail_rowid({ok, DetailRowid}, WA, Srv, {MkMasterComp, Relationship, Data}) ->
  RowId = [{PK, wslib:gv(FK, DetailRowid)} || {PK, FK} <- Relationship],
  {MasterComp, MasterEvent} =
    fmt_mk_ret(MkMasterComp(create_row, RowId, Data, WA), {create_row, RowId}),
  {exec, MasterEvent, MasterComp};
detail_rowid(_, _, _, _) ->
  {stop, ok}.

fmt_mk_ret({ok, Comp, Event}, _) ->
  {Comp, Event};
fmt_mk_ret({ok, Comp}, DefaultEvent) ->
  {Comp, DefaultEvent}.
