%%% File    : expand_row_hook.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%% Created : 30 Aug 2003 by  <svg@surnet.ru>

%%
%% $Id: expand_row_hook.erl,v 1.3 2003/11/01 12:11:36 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wsform.expand_row_hook).

-behaviour('wscomp.expand').

-export([init/1, is_active/3, access_info/3, handle_event/5, handle_call/4]).

-import(.wsdcomp).
-import(.wscomp.expand).

-record(state, {hook, hdata, comp_name}).

init({Hook, HookData, CompName}) ->
  {ok, HD} = Hook(init, HookData),
  {ok, #state{hook=wscomp.expand:mk_hook(Hook),
	      hdata=HD,
	      comp_name=CompName}
  }.

is_active(WA, Srv, S=#state{hook=H, hdata=HD, comp_name=undefined}) ->
  (wsdcomp:super_any_state(Srv, mode) == view)
    and H({is_active, WA, Srv}, HD);
is_active(WA, Srv, S=#state{hook=H, hdata=HD, comp_name=CN}) ->
  (wsdcomp:super_any_state(Srv, mode) == view)
    and (not wsdcomp:is_alive(Srv, CN))
    and H({is_active, WA, Srv}, HD).

access_info(WA, Srv, S=#state{hook=H, hdata=HD}) ->
  H({access_info, WA, Srv}, HD).

handle_call(Event, WA, Srv, S=#state{hook=H, hdata=HD}) ->
  {Ret, NxtHD} = wscomp.expand:call_hook({call, Event, WA, Srv}, H, HD),
  {Ret,  S#state{hdata=NxtHD}}.
 
handle_event(Msg, CN, WA, Srv, S=#state{hook=H, hdata=HD, comp_name=CN}) ->
  wsdcomp:display(Srv, [CN], false),
  {Ret, NxtHD} =
    wscomp.expand:call_hook({event, Msg, CN, WA, Srv}, H, HD),
  {Ret,  S#state{hdata=NxtHD}};
handle_event(Msg, From, WA, Srv,
	     S=#state{hook=H, hdata=HD}) ->
  {Ret, NxtHD} = wscomp.expand:call_hook({event, Msg, From, WA, Srv}, H, HD),
  {Ret,  S#state{hdata=NxtHD}}.

