%%%-------------------------------------------------------------------
%%% File    : wstl_sup.erl
%%% Author  :  <svg@surnet.ru>
%%% Description : 
%%%
%%% Created : 25 Apr 2003 by  <svg@surnet.ru>
%%%-------------------------------------------------------------------
%%
%% $Id: wstl_sup.erl,v 1.1.1.1 2003/05/05 20:20:59 vsekissov Exp $
%%
%%**
%% 
%% @doc
%% @end
%%*
-module(wstl_sup).

-behaviour(supervisor).

-export([start_link/0]).
-export([init/1]).

-define(server, ?MODULE).

start_link() ->
  supervisor:start_link({local, ?server}, ?MODULE, []).

%%====================================================================
%% Server functions
%%====================================================================
%%--------------------------------------------------------------------
%% Func: init/1
%% Returns: {ok,  {SupFlags,  [ChildSpec]}} |
%%          ignore                          |
%%          {error, Reason}   
%%--------------------------------------------------------------------
init([]) ->
  ContController = {wscc, {wscc, start_link, []},
		    permanent, 5000, worker, [wscc]},
  MsgSrv = {wsmessage,{wsmessage, start_link, []},
	    permanent, 5000, worker, [wsmessage]},
  ApplicationMgr = {wsapplication_mgr, {wsapplication_mgr, start_link, []},
		    permanent, 10000, worker, [wsapplication_mgr]},
  {ok,{{one_for_all, 0, 1000}, [ContController, MsgSrv, ApplicationMgr]}}.

%%====================================================================
%% Internal functions
%%====================================================================
